#!/bin/bash

ServiceList=("acpid")

if [ $# -ne 1 ]; then
	echo "usage $0 service_name"
	exit -1
fi

service=""
for serviceName in ${ServiceList[@]}
do
	if [ "$serviceName" = "$1" ]; then
		service=$1
		break;
	fi
done

if [ "$service" = "" ]; then
	echo "invalid service name : [$1]"
	exit -1
fi

for loop in `seq 1 5`
do
	serviceStatus=`/usr/sbin/service $service status | awk '{print $2}' | sed 's/,//'`
	if [ "$serviceStatus" != "start/running" ]; then
		logger -t StartAile $service"(call start)"
		sudo /usr/sbin/service $service start
	else
		break;
	fi
done

serviceStatus=`/usr/sbin/service $service status | awk '{print $2}' | sed 's/,//'`
if [ "$serviceStatus" != "start/running" ]; then
	logger -t StartAile $service"(start failure)"
else
	logger -t StartAile $service"(started)"
fi

